<?php

class Kohana_Account {
    
    protected static $_instance;
    protected $_config;
    protected $_model;

    /**
     * Вовзращает экземпляр класса (singleton-паттерн)
     *
     * @return  instance
     */     
    public static function instance() {
        if(!isset(self::$_instance))
        {
            $config = Kohana::$config->load('account');
            self::$_instance = new self($config);
        }
        return self::$_instance;
    }
    
    private function __construct($config = array()) {
        $this->_config = $config;
        $this->_model = new Model_Account;
    }
    
    /**
     * Генерирует уникальный код активации для данных входных параметров.
     *
     * @param  string $FirstName Имя
     * @param  string $SecondName Отчество
     * @param  string $LastName Фамилия
     * @return  string
     */       
    protected function generateActivationCode($firstName, $secondName, $lastName)
    {
        $activationCode = UTF8::substr(md5($firstName.$secondName.$lastName.rand()), 0, 8);
        while(UTF8::strpos($activationCode, '0') !== FALSE)
            UTF8::str_ireplace('0', 'e', $activationCode);
        while(UTF8::strpos($activationCode, 'o') !== FALSE)
            UTF8::str_ireplace('0', 'h', $activationCode);
        return UTF8::strtoupper($activationCode);
    }
    
    public function createTeacher($firstName, $secondName, $lastName, $degreeID, $departamentID)
    {
        $activationCode = $this->generateActivationCode($firstName, $secondName, $lastName);
        $this->_model->createTeacher($firstName, $secondName, $lastName, $degreeID, $departamentID, $activationCode);
        return $activationCode;
    }
    
    public function createStudent($firstName, $secondName, $lastName, $grade, $groupNum, $facultyID)
    {
        $activationCode = $this->generateActivationCode($firstName, $secondName, $lastName);
        $this->_model->createStudent($firstName, $secondName, $lastName, $grade, $groupNum, $facultyID, $activationCode);
        return $activationCode;
    }
    
    public function isLoginExists($login)
    {
        $login_count = $this->_model->getAccNumByLogin($login);
        return $login_count > 0;
    }
    
    public function isMailExists($email)
    {
        $email_count = $this->_model->getAccNumByMail($email);
        return $email_count > 0;
    }
    
    public function changeLogin($id, $newLogin)
    {
        
    }
    
    public function changeEMail($id, $newEMail)
    {
        
    }
    
    public function changePassword($id, $newPassword)
    {
        
    }
        
    
}